﻿
// マイコンとの通信用にSerialPortクラスに少し追加
// 2011年3月30日作成
// http://kyoutan.jpn.org


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;  // 追加

namespace uart
{
    
    public class uartctl : SerialPort
    {
        // 1バイト送信
        public bool putch(byte a)
        {
            byte[] buff = new byte[1];

            buff[0] = a;
            try
            {
                base.Write(buff, 0, 1);
            }
            catch
            {
                return false;
            }
            return true;
        }

        // 指定サイズを受信するまで待つ
        // タイムアウトはserialPortのReadTimeoutプロパティで指定
        public bool readbyte(byte[] buff, int size)
        {
            bool ret = true;

            try
            {
                int offset = 0;
                while (true)    // 指定したサイズを読むまで繰り返す
                {
                    int readsize;
                    readsize = base.Read(buff, offset, size);
                    if (readsize == size) break;    // 実際に指定したサイズを読んだら終了
                    else
                    {
                        size -= readsize;
                        offset += readsize;
                    }
                }
            }
            catch
            {
                // タイムアウトとかの例外が発生した時
                ret = false;
                //putmsg("受信エラー");
            }

            return ret;
        }
    }
}
